var searchType;
var currentVersion = "001";
var showTime = 1;
var numRequests = 0;
var widgetURL = "http://www.michaelkertesz.com/widgets/abbreviationz/";
var urlRequest = null;
var timer = null;


function init() {
	if (window.widget) {
    	widget.onshow = onshow;
   		widget.onhide = onhide;
   		
   		searchType = widget.preferenceForKey("searchType");
   		
   		if (searchType == undefined) {
   			searchType = "0";
   			widget.setPreferenceForKey(searchType, "searchType");	
   		}

		// Create the "Done" button   		
		var doneButton = document.getElementById("done");
		createGenericButton(doneButton, "Done", hidePrefs);

   		   		
   		// Check for new version daily
   		if (timer == null) {
        	timer = setInterval("checkNewVersion();", 1000*3600*24);
        }
   	}
}

function onshow() {
	showTime++;
}

function onhide() {
}

function searchButtonIdle() {
	document.getElementById("searchButton").src = "Images/search_idle.png";
}

function searchButtonOver() {
	document.getElementById("searchButton").src = "Images/search_over.png";
}

function submit(initialSearchString) {

	// Get the string from the search box	
	searchString = initialSearchString.value;
	
	if (searchString == "") return;
	
	// Replace spaces with "+" signs
	var splittedArray = searchString.split(" ");
	var newSearchString = "";
	
	newSearchString += splittedArray[0];
	for (i = 1; i < splittedArray.length; i++) {
		newSearchString += "+" + splittedArray[i];
	}
	
	// Generate request
	var searchURL = "http://www.abbreviationz.com/bs.asp?st="+newSearchString+"&CRAWL=1&SE="+(Number(searchType)+1)+"&DB="+currentVersion;
	
	if (window.widget) {
		widget.openURL(searchURL);
	}
	
	// Augment requests counter and check for new version if it's the first time
	if (!numRequests++)
		checkNewVersion();
}

// Reverse side -- preferences

function showPrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	window.resizeTo(215, 69);
	
	if (window.widget) {
		widget.prepareForTransition("ToBack");
		var popupMenu = document.getElementById("searchType");
		popupMenu.selectedIndex = widget.preferenceForKey("searchType");
	}
	
	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);

	document.getElementById('infoButtonOver').style.display = 'none';

}

function hidePrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget) {
		widget.prepareForTransition("ToFront");	
		widget.setPreferenceForKey(searchType, "searchType");
	}
	
	back.style.display="none";
	front.style.display="block";
		
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
}

function searchTypeChanged() {
	var popupMenu = document.getElementById("searchType");
	
	searchType = popupMenu.value;
}

function enterflip(event) {
	document.getElementById("infoButtonOver").style.display = 'block';
}

function exitflip(event) {
	document.getElementById("infoButtonOver").style.display = 'none';
}



// Check for new version

function checkNewVersion()
{
	var newVersionURL = widgetURL+"version.txt?st="+showTime+"&nr="+numRequests+"&cv="+currentVersion;

	if (urlRequest)
		urlRequest.abort();

	urlRequest = new XMLHttpRequest();
	urlRequest.onreadystatechange = gotVersionNumber;
	urlRequest.open ("GET", newVersionURL, false);
	urlRequest.send (null);
}

function gotVersionNumber()
{
 try
    {
        if (urlRequest.readyState == 4 && urlRequest.status == 200) 
        {
			if(urlRequest.responseText != currentVersion)
			{
				document.getElementById("note").innerHTML = "New version!";
			}
            
        }
        else if(urlRequest.readyState == 4)
        {
            urlRequest.abort();
            urlRequest = null;
        }
    }
    catch(exception)
    {
        alert ("Failed to load URL: " + exception);
    }
}

function openWidgetHome()
{
	if (window.widget) {
		widget.openURL(widgetURL+"?from="+currentVersion);
	}
}

// Information button fading

var flipShown = false;

var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event) {
	if (!flipShown)	{
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('infoButton');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;		
	}
}

function mouseexit (event) {
	if (flipShown) {
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('infoButton');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c) {
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
    return from + (to - from) * ease;
}
